#!/usr/bin/env python
# -*- coding: utf-8 -*-

#***************************************************************************
#*   Copyright (C) 2008-2008 by Steve Walter                               *
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation; either version 3 of the License, or     *
#*   (at your option) any later version.                                   *
#*                                                                         *
#*   This program is distributed in the hope that it will be useful,       *
#*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
#*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
#*   GNU General Public License for more details.                          *
#*                                                                         *
#*   You should have received a copy of the GNU General Public License     *
#*   along with this program; if not, write to the                         *
#*   Free Software Foundation, Inc.,                                       *
#*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
#***************************************************************************

#Bibliotheken
#import Tkinter
#import Menue
#import Pmw
#import Mittel_T
#import Dialog22
#import File
import Calc
#import Draw

#Funktionen und Co einlesen
from Menue import *
from Tkinter import *
from Mittel_T import *
from Dialog22 import *
from File import *
from Calc import *
from Draw import *

class CMainWindow:
    def __init__(self):
        #Tk initialisieren
        self.root = Tk()
        self.root.geometry('640x480')
        self.szTitle = 'Mittel'
        self.root.title(self.szTitle)
        
        #Workspace definieren
        self.Workspace = CWorkspace(self.root)  
        #Variablen
        self.Variablen = CVariablen()
        self.Variablen.InitVars()
        
        #Zeichenroutine erstellen
        self.Zeichnen = CZeichnen(self.Workspace,  self)
        
        #Menü erstellen
        self.Menu = CMenu(self.root, self)
        
        self.Workspace.pack(fill=BOTH,  expand=1)
        #IO erstellen
	#self.Calc = CCalc(self)
        self.IO = CIO(self.Variablen,  self)
        self.Calc = CCalc(self)
    
    def main(self):
        self.root.mainloop()

class CWorkspace(Frame):
    def __init__(self,  master=None, Main=None,  **kw):
        Frame.__init__(self, master, kw)
        self.bBelegt = False
        self.Instance = None
    
    def add(self,  instance, **kw):
        #Gleich Instanz?
        if instance == self.Instance:
            return
        
        #Von einer anderen Instanz belegt?
        if self.bBelegt:
            self.Instance.destroy()
        
        #Instanz anzeigen
        instance.pack( **kw)
        self.Instance = instance
        self.bBelegt=True
    
    def remove(self,  instance):
        #Gleiche Instanz?
        if instance == self.Instance:
            self.Instance=None
            self.bBelegt = False
    
if __name__ == '__main__':
    Main = CMainWindow()
    Main.main()
